function Flagfox_error(showpopup, message, exception)
{
    if (!message && !exception)
    {
        Flagfox_error(true,"Unknown error; bad error handling",null);
        return;
    }

    // Put an error message in the error console (set "javascript.options.showInConsole" to true to view)
    var consoleerror = "Flagfox";
    if (message)
        consoleerror += " ERROR: " + message;
    if (exception)
        consoleerror += " EXCEPTION: " + exception;
    Components.utils.reportError(consoleerror);  // all one line

    // Popup an error message dialog with a button to go to the forums
    if (showpopup)
    {
        var popuperror = "Sorry, Flagfox has encountered a problem.  " +
                         "Please report this message on our forums using the button below.  (English only)";
        if (message)
            popuperror += "\n\nERROR MESSAGE: " + message;
        if (exception)
            popuperror += "\n\nEXCEPTION THROWN: " + exception;

        try
        {
            const prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                                      .getService(Components.interfaces.nsIPromptService);
            const flags = prompts.BUTTON_POS_0 * prompts.BUTTON_TITLE_OK +
                          prompts.BUTTON_POS_1 * prompts.BUTTON_TITLE_IS_STRING +
                          prompts.BUTTON_POS_0_DEFAULT;
            var button = prompts.confirmEx( null, "Flagfox Error!", popuperror, flags, "", "Report", "", null, {} );

            if (button == 1)  // "Report" button
            {
                // Find the browser for the most recent window, regardless of where this function was called from
                const currentBrowser = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                                                 .getService(Components.interfaces.nsIWindowMediator)
                                                 .getMostRecentWindow("navigator:browser")
                                                 .getBrowser();
                // Open forum in new tab (can't open new window; if error is on startup, we could hit another error)
                currentBrowser.selectedTab = currentBrowser.addTab("http://flagfox.servehttp.com/forum/viewforum.php?f=3",null,null);
            }
        }
        catch (e) { Flagfox_error(false,"Failed to handle error prompt",e); }
    }
}
